package lab.game;

import javafx.animation.AnimationTimer;
import javafx.scene.canvas.Canvas;
import javafx.scene.canvas.GraphicsContext;

public class DrawingThread extends AnimationTimer {

	private final GraphicsContext gc;
	private Level level;
	private long lastTime;

	public DrawingThread(Canvas canvas, Level level) {
		this.level = level;
		this.gc = canvas.getGraphicsContext2D();
		lastTime = System.nanoTime();
	}

	/**
	 * Draws objects into the canvas. Put you code here.
	 */
	@Override
	public void handle(long now) {
		level.draw(gc);
		level.simulate(now - lastTime);
		lastTime = now;
	}

}
